diff -c -r postgresql-jdbc-8.3dev-600.src.orig/org/postgresql/ds/common/BaseDataSource.java postgresql-jdbc-8.3dev-600.src/org/postgresql/ds/common/BaseDataSource.java
*** postgresql-jdbc-8.3dev-600.src.orig/org/postgresql/ds/common/BaseDataSource.java	2005-02-03 00:30:31.000000000 +0100
--- postgresql-jdbc-8.3dev-600.src/org/postgresql/ds/common/BaseDataSource.java	2007-06-18 12:04:29.000000000 +0200
***************
*** 50,55 ****
--- 50,56 ----
      private int portNumber;
      private int prepareThreshold;
      private int loginTimeout; // in seconds
+     private boolean ssl;
  
      /**
       * Gets a connection to the PostgreSQL database.  The database is identified by the
***************
*** 262,274 ****
      }
  
      /**
       * Generates a DriverManager URL from the other properties supplied.
       */
      private String getUrl()
      {
          return
              "jdbc:postgresql://" + serverName + (portNumber == 0 ? "" : ":" + portNumber) + "/" + databaseName +
!             "?loginTimeout=" + loginTimeout + "&prepareThreshold=" + prepareThreshold;
      }
  
      /**
--- 263,296 ----
      }
  
      /**
+      * Set whether the connection will be SSL encrypted or not.
+      *
+      * @param enabled if <code>true</code>, connect with SSL.
+      */
+     public void setSsl(boolean enabled)
+     {
+         this.ssl = enabled;
+     }
+ 
+     /**
+      * Gets SSL encryption setting.
+      *
+      * @return <code>true</code> if connections will be encrypted with SSL.
+      */
+     public boolean getSsl()
+     {
+         return this.ssl;
+     }
+ 
+     /**
       * Generates a DriverManager URL from the other properties supplied.
       */
      private String getUrl()
      {
          return
              "jdbc:postgresql://" + serverName + (portNumber == 0 ? "" : ":" + portNumber) + "/" + databaseName +
!             "?loginTimeout=" + loginTimeout + "&prepareThreshold=" + prepareThreshold +
!             (this.ssl ? "&ssl&sslfactory=org.postgresql.ssl.NonValidatingFactory" : "");
      }
  
      /**
***************
*** 301,306 ****
--- 323,329 ----
          
          ref.add(new StringRefAddr("prepareThreshold", Integer.toString(prepareThreshold)));
          ref.add(new StringRefAddr("loginTimeout", Integer.toString(loginTimeout)));
+         ref.add(new StringRefAddr("ssl", Boolean.toString(ssl)));
          return ref;
      }
  
***************
*** 313,318 ****
--- 336,342 ----
          out.writeInt(portNumber);
          out.writeInt(prepareThreshold);
          out.writeInt(loginTimeout);
+         out.writeBoolean(ssl);
      }
  
      protected void readBaseObject(ObjectInputStream in) throws IOException, ClassNotFoundException
***************
*** 324,329 ****
--- 348,354 ----
          portNumber = in.readInt();
          prepareThreshold = in.readInt();
          loginTimeout = in.readInt();
+         ssl = in.readBoolean();
      }
  
  }
